//	au.c
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>
int audio_fd= -1;
int play_precision;
int play_stereo;
int play_sample_rate;
int freq= 44100;
int volume= 80;//0-100
int noc= 2;//num of channel

void
x(char *c){ fprintf(stderr,c); exit(1); }

void
aclose(){ close(audio_fd); }

void
awrite(char* buf, int len) {
	int n;
	while(len) {
		if ((n= write (audio_fd, buf, len)) < 0) {
			if (errno != EINTR)
				{ perror("write to /dev/dsp failed"); exit(1); }
			n= 0;
		}
	len-= n; buf+= n;
	}
}

void
set_vol(int volume) {
	int fd,ret,vol_chan,devices;
	if ((fd= open ("/dev/mixer", O_WRONLY | O_NDELAY, 0))< 0)
		x("audio /dev/mixer is busy or can't be opened\n");
	ret= ioctl(fd, SOUND_MIXER_READ_DEVMASK, &devices);
	if (ret== -1) devices= 0;
	if (devices & (1 << SOUND_MIXER_PCM))
		vol_chan= SOUND_MIXER_PCM;
	else    vol_chan= SOUND_MIXER_VOLUME;
	volume |= volume << 8;
	if( ioctl(fd, MIXER_WRITE(vol_chan), &volume)== -1)
		x("config of /dev/mixer failed\n");
	close(fd);
}

void
aopen(noc,freq,volume) {
	int fd, flags;
	if ((fd= open ("/dev/dsp", O_WRONLY | O_NDELAY, 0))< 0)
		x("audio /dev/dsp is busy or can't be opened\n");
	/* turn NDELAY mode off: */
	if ((flags= fcntl (fd,F_GETFL,0))< 0)
		x("fcntl F_GETFL on /dev/audio failed\n");
	flags &= ~O_NDELAY;
	if (fcntl (fd,F_SETFL,flags)<0)
		x("fcntl F_SETFL on /dev/audio failed\n");
	audio_fd= fd;
	/* configure the device: */
	play_precision= 16;
	play_stereo= noc-1;
	play_sample_rate= freq;
	if(
	ioctl(audio_fd, SNDCTL_DSP_SAMPLESIZE, &play_precision)== -1 ||
	ioctl(audio_fd, SNDCTL_DSP_STEREO, &play_stereo)== -1 ||
	ioctl(audio_fd, SNDCTL_DSP_SPEED, &play_sample_rate)== -1
	) x("config of /dev/dsp failed\n");
	if(volume)set_vol(volume);
}
