
//	de.c

#include "dm.h"
FILE	*bs;			// file pointer for bitstream
FILE	*out;			// file pointer for output wave
int	ms;			// ms-stereo flag
int	obf[CH][L];		// output buffer
int	diff[CH][BL];		// predicted difference
int	rcoef[CH][BL];		// reconstructed coeff
int	qm[BL];			// quantize matrix
int	qp[CH];			// quantize parameter
int	gmin[CH];		// for mdct.c
Ui buf= 0;
Ui bs8= 0;
int cnt= -4;

/*
**	fld() : fixed length decoder
**	FLC decoder (bit<=24 and byte aligned codes bit<=32)
*/
int fld(int bit){
	int j,code,res;

	j= 8-(bs8&7); bs8 += bit;
	code= buf>>(32- bit);
	while(bit>=j){
		buf<<=j; bit-= j; j= 8;
		if((res= getc(bs))==EOF) { if(cnt++>=0) exit(0); }
		 else buf|= res;
		}
	buf<<=bit;
	return code;
}

/*
**	vld() : variable length decoder
*/
int vld(int *cd,int *ln,int len){
	int    i,code;
	for(i=0;i<len;i++) if((buf>>(32-ln[i])) == cd[i])break;
	if(i<len) code= fld(ln[i]);
	 else exit(1);
	return i;
}


/*
**
**	decode() : decode one frame
**
*/

void decode(ch,m) {
	int i, q;

	if(ch==0) ms= fld(1);		// ms-stereo flag
	qp[ch]= fld(12)*MINQ;		// quantize param

	for(i=0;i<BL;i++)rcoef[ch][i]= 0;
	i= -1;
	while(1){
		int ind= vld(cod,len,HTL);
		if(ind==eob) break;	// eob ?
		 else if(ind==esc){	// escape ?
			int n=  1;
			int q0= -1;
			int ru= 0;
			i+= ru= fld(BLL);// run decode
			do {q0+=1<<n; n++;} while(fld(1)==0);
			q= fld(n)+q0;	// level decode
		} else {		// normal vlc decode
			i+= run[ind]; q=  level[ind];
		}
		if(fld(1))q= -q;	// sign decode
		rcoef[ch][i]= q*qp[ch]*qm[i]/QV; // dequantize
		}
	}

/*
**	proc()
*/

void proc() {
	static int lm,m;
	int nm= fld(3);
	decode(0,m); decode(1,m);
	imdct(rcoef,obf,lm,m,nm);
	lm= m;
	m= nm;
}


/*
**	usage()
*/
void usage(char *c){
fprintf(stderr," Usage: %s [-v V] [file(.dms) [rcst.wav]]\n file.dms: bitstream file (.dms can be reduced) (def. stdin)\n rcst.wav: reconst wav file (def. audio device)\n -v volume: 0-100 (def. 80)\n",c);
	exit(1);
}

/*
**	main()
*/
int main(argc,argv) char **argv; {
	int i,vol= 80;
	char fn[256];
	char *cmd= *argv;
	bs= stdin; out= stdout;
	init_ct();
	argc--; argv++;
	while(argc){
		if(strcmp(*argv,"-v")==0) { argc--; argv++; vol= atoi(*argv); }
		else if(**argv=='-') usage(cmd);
		else break;
		argc--; argv++;
		}

	if(argc){
		strcpy(fn,*argv++); argc--;
		if(strlen(fn)<=250 && strcmp(fn+strlen(fn)-4,".dms")) strcat(fn,".dms");
		if(!(bs= fopen(fn,"r"))) { fprintf(stderr,"%s: can't open\n",fn); exit(1); }
		if(argc){
			if(!(out= fopen(*argv,"wb")))
			{ fprintf(stderr,"%s: can't create\n",*argv); exit(1); }
			audio= 0;
		}
	}
	if(audio) aopen(2,44100,vol);	// init audio device
	fld(32);			// init fld()
	for(i=0;i<44;i++) { int c= fld(8); if(audio==0) putc(c,out); } // reconst wave header
	while(1) proc();		// eternal loop!
	//aclose();
	return 0;
}
