/*
**	mdct.c
*/
#include "dm.h"
typedef float CFFTtype;
typedef float FFTtype;
extern int qm[BL];
CFFTtype arr[1<<BLL];
float cw[M][M][BL];
float MD[2][BL*2];
int audio= 1;

FFTtype**
xalloc(n,m) {
	int i; FFTtype **t;
	t= (FFTtype **) malloc(n * sizeof (FFTtype *));
	if(!t){ fprintf(stderr,"cdnt xaloc\n"); exit(1); }
	for (i=0;i<n;i++) {
		t[i]= (FFTtype *) malloc(m * sizeof(FFTtype));
		if (!t[i]) { fprintf(stderr,"cdnt aloc m\n"); exit(1); }
		}
	return t;
	}

void
fft (x,nn,f)	// 2' power pt FFT
FFTtype *x; {
	int n, mmax, m, j, i;
	float t, wr, wi, wpr, wpi;
	float tr, ti, xr, xi, x1r, x1i;
	n= nn*2;
	j= 0; // bit reversal
	for (i= 0; i< n; i+= 2) {
		if (j > i) {
			tr= x[j  ]; x[j  ]= x[i  ]; x[i  ]= tr;
			ti= x[j+1]; x[j+1]= x[i+1]; x[i+1]= ti;
			}
		m= nn;
		while (m >= 2 && j >= m) { j-= m; m>>= 1; }
		j+= m;
		}
	wpr= -1; wpi=  0;
	for (mmax= 2; n> mmax; mmax*= 2) {
		wr= 1.; wi= 0.;
		for (m=0; m< mmax; m+= 2) {
			j= m+mmax;
			x1r= x[j  ]; x1i= x[j+1];
			tr= wr*x1r; ti= wi*x1i;
			for (i= m; i< n - mmax*2; i+= mmax*2) {
				tr-= ti;
				ti= wr * x1i + wi *x1r;
				x1r= x[j+mmax*2  ];
				x1i= x[j+mmax*2+1];
				xr= x[i  ]; xi= x[i+1];
				x[i  ]= xr + tr; x[i+1]= xi + ti;
				x[j  ]= xr - tr; x[j+1]= xi - ti;
				tr= wr * x1r;
				ti= wi * x1i;
				j+= mmax*2;
				}
			tr-= ti;
			ti= wr*x1i + wi*x1r;
			xr= x[i  ]; xi= x[i+1];
			x[i  ]= xr + tr; x[i+1]= xi + ti;
			x[j  ]= xr - tr; x[j+1]= xi - ti;
			t= wr;
			wr= t*wpr - wi*wpi;
			wi= t*wpi + wi*wpr;
			}
		wpr*= .5;
		wpi= sqrt(.5-wpr)*f;
		wpr= sqrt(.5+wpr);
		}
	}

#if 0
void
compfft (x,nn,f) /* no 1/N factor, free n point complex FFT */
CFFTtype *x; {
	int i, j, k, l, p1, q1, m, n, logq1;
	static FFTtype **d= 0;
	float ai, ca, sa, wr, wi, o, ca1, sa1, tr, ti;
	n= nn;
	logq1= 0;
	/* Factorize n;  n= p1*q1 where q1 is a power of 2.
	For n=1152, p1=9, q1=128.*/
	while(1){
		m= n >> 1;
		if ((m << 1) == n) { logq1++; n= m; }
		  else break;
		}
	if(n==1) return fft(x,nn,f);
	p1= n;
	q1= 1<<logq1;
	{
	static int oldp1= 0, oldq1= 0;
	if (oldp1< p1 || oldq1< q1) {
		if (d) { free(d); d= 0; }
		if (oldp1< p1) oldp1= p1;
		if (oldq1< q1) oldq1= q1;;
		}
	if (!d) d= xalloc(oldp1, 2 * oldq1);
	}
	/* Sort the p1 sequences */
	for (i=0;i<p1;i++)
	for (j=0;j<q1;j++){
		d[i][2*j  ]= x[2*(p1*j+i)  ];
		d[i][2*j+1]= x[2*(p1*j+i)+1];
		}
/* compute the power of two fft of the p1 sequences of length q1 */

	for(i=0;i<p1;i++) fft(d[i], q1, f);/* 2'power FFT */

/* combine the FFT results into one sequence of length N */
	ca1= cos(2*M_PI/nn);
	sa1= sin(2*M_PI/nn);
	ca= 1.; sa= 0.;
	for (k= 0; k< nn*2; k+=2) {
		wr= 1.; wi= 0.;
		l= ((k/2)%q1)*2;
		tr= d[0][l]; ti= d[0][l+1];
		for (j= 1; j< p1; j++) {
			o= wr; wr= o*ca - wi*sa;
			wi= o*sa + wi*ca;
			ai= f*wi;
			tr+= d[j][l]*wr-d[j][l+1]*ai;
			ti+= d[j][l]*ai+d[j][l+1]*wr;
			}
		x[k]= tr; x[k+1]= ti;
		o= ca;
		ca= o*ca1 - sa*sa1;
		sa= o*sa1 + sa*ca1;
		}
	}
#endif

void
mdct(x,n,f) // f=1: forward, -1: inv,  n is / 2
float *x; {
	float re,im;
	int i,j,a= n>>1,b= n+a;
	float c,s,co,cf,sf,fr= M_PI/n,c0,s0;

	cf= cos(fr); sf= f*sin(fr);
	c= cos(fr/8.); s= f*sin(fr/8.);
	c0= c*sqrt(2./n); s0= s*sqrt(2./n);
	for(i=0;i<n;i+=2){
		j= n-1-i;
		if(f==1){
		if(i<a){ re= x[a+j]+x[b+i]; im= x[a+i]-x[j-a]; }
		 else  { re= x[a+j]-x[i-a]; im= x[a+i]+x[b+j]; }
		} else { re= -x[i]; im= x[j]; }
		arr[i  ]= re*c + im*s;
		arr[i+1]= im*c - re*s;
		co= c; c= c*cf-s*sf; s= s*cf+co*sf;
		}
	fft(arr,a,-f);	//compfft(arr,a,-f);
	c= c0; s= s0;
	for(i=0;i<n;i+=2){
		j= n-1-i;
		re= arr[i  ]*c + arr[i+1]*s;
		im= arr[i+1]*c - arr[i  ]*s;
		if(f==1){ x[i]= -re; x[j]= im; }
		  else { x[a+j]= re; x[a+i]= im;
		if(i<a){ x[b+i]= re; x[j-a]= -im; }
		 else  { x[i-a]= -re; x[b+j]= im; }
		}
		co= c; c= c*cf-s*sf; s= s*cf+co*sf;
		}
	}

void
aul(lm,ou) //	output  last frame
int ou[CH][L];
	{
	static short buf[BL*2];
	static unsigned int p;
	static int start=1;
	unsigned int i,n= BL>>lm;
	static int x,y;

	if(start) start= 0;
	 else {
		for(i=0;i<n;i++) {
			x+= ou[0][(p+i)&L1];
			y+= ou[1][(p+i)&L1];
			if(x<SMIN)x= SMIN;
			if(x>SMAX)x= SMAX;
			buf[i*2]= x;
			x-= x/LEAK;
			if(y<SMIN)y= SMIN;
			if(y>SMAX)y= SMAX;
			buf[i*2+1]= y;
			y-= y/LEAK;
			}
		if(audio) awrite(buf,4*n);
		else fwrite(buf,4,n,out);
		p+= n;
		}
	}

static int op;
extern int obf[2][L];

void
fmdct(in,ou,lm,m,nm)
int in[CH][L],ou[CH][BL];
	{
	static int p;
	int i,ch,n= BL>>m;
	double x2=0,xy= 0;
	double a0= 0, a1= 0;

	for(ch=0;ch<CH;ch++){
		for(i=0;i<n;i++) MD[ch][i]= (in[ch][(p-n/2+i)&L1]
#ifdef Pred
			-obf[ch][(op-n/2+i)&L1]
#endif
			)*cw[lm][m][n-1-i];
		for( ;i<n*2;i++) MD[ch][i]= in[ch][(p-n/2+i)&L1]*cw[nm][m][i-n];
		}

	mdct(MD[0],n,1);
	mdct(MD[1],n,1);

	for(i=0;i<n;i++) {
		float x= MD[0][i];
		float y= MD[1][i];
		a0+= x*x; a1+= y*y;
		x2+= x*x-y*y;
		xy+= x*y;
		}
	if(x2<0)x2= -x2;
	if(xy<0)xy= -xy;
	ms= xy > x2;	// not (xy*2>x2) because /2 in enccoder
	if(ms) {
		a0= a1= 0;
		for(i=0;i<n;i++) {
		int d,e;
		float x= MD[0][i];
		float y= MD[1][i];
		d= (MD[0][i]= (x+y)*.5);
		e= (MD[1][i]= (x-y)*.5);
		a0+= d*d; a1+= e*e;
		}
	}
	gmin[0]= sqrt(sqrt(a0*BL/n)); gmin[1]= sqrt(sqrt(a1*BL/n));

	for(i=0;i<n;i++){ ou[0][i]= MD[0][i]; ou[1][i]= MD[1][i]; }
	p+= n;
	}
void
imdct(in,ou,lm,m,nm)
int in[CH][BL],ou[CH][L];
	{
	static int p;
	int i,ch,n= BL>>m;

	for(i=0;i<n;i++) {
		if(ms) { MD[0][i]= in[0][i]+in[1][i]; MD[1][i]= in[0][i]-in[1][i]; }
		else   { MD[0][i]= in[0][i];	      MD[1][i]= in[1][i];	   }
	}
	mdct(MD[0],n,-1);
	mdct(MD[1],n,-1);
	for(ch=0;ch<CH;ch++){
		for(i=0;i<n;i++) ou[ch][(p-n/2+i)&L1]+= cw[lm][m][n-1-i]*MD[ch][i];
		for( ;i<n*2;i++) ou[ch][(p-n/2+i)&L1] = cw[nm][m][i-n]*MD[ch][i];
		if(nm<m) for(i=n/2;i<(BL>>nm)/2;i++) ou[ch][(p+n+i)&L1]= 0;
		}
	aul(lm,ou);
	p+= n;
	op= p;
	}
void
init_ct() { int i,k,m,n;
	for(i=0;i<BL;i++) qm[i]= QV/4+i*QV/BL;
	for(m=0;m<M;m++){
		n= BL>>m;
		for(k=0;k<M;k++){
			int ln= BL>>k, i0= (n-ln)/2, i1= (n+ln)/2;
			if(k>m) for(i=0;i<n;i++) {
				float t;
				if(i<i0) t= 1.;
				else if(i<i1) t= cos(M_PI*(i-i0+.5)/(2*ln));
				else t= 0.;
				cw[k][m][i]= t;
				}
			else for(i=0;i<n;i++) cw[k][m][i]= cos(M_PI*(i+.5)/(2*n));
			}
		}
	}
